searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for `GamesEngine`.","ref":"GamesEngine.html","title":"GamesEngine","type":"module"},{"doc":"Hello world.","ref":"GamesEngine.html#hello/0","title":"GamesEngine.hello/0","type":"function"},{"doc":"iex> GamesEngine.hello()\n    :world","ref":"GamesEngine.html#hello/0-examples","title":"Examples - GamesEngine.hello/0","type":"function"},{"doc":"Grid component - represents a collection of Coordinates","ref":"GamesEngine.Grid.html","title":"GamesEngine.Grid","type":"module"},{"doc":"Adds a new attributes to a `%Tile{}`\nWill not overwrite the attribute if it already exists","ref":"GamesEngine.Grid.html#add_tile_attribute/4","title":"GamesEngine.Grid.add_tile_attribute/4","type":"function"},{"doc":"Creates a new `%Grid{}` struct\nAutomatically populates the `:coordinates` attribute with a map of\n`%Coordinate{}`s based on the supplied dimensions","ref":"GamesEngine.Grid.html#new/2","title":"GamesEngine.Grid.new/2","type":"function"},{"doc":"Populates a `%Grid{}` with `%Tile{}`s","ref":"GamesEngine.Grid.html#populate/2","title":"GamesEngine.Grid.populate/2","type":"function"},{"doc":"Replaces the attributes of a tile","ref":"GamesEngine.Grid.html#replace_tile_attributes/3","title":"GamesEngine.Grid.replace_tile_attributes/3","type":"function"},{"doc":"Updates an existing attribute of a `%Tile{}`","ref":"GamesEngine.Grid.html#update_tile_attribute/4","title":"GamesEngine.Grid.update_tile_attribute/4","type":"function"},{"doc":"","ref":"GamesEngine.Grid.html#t:t/0","title":"GamesEngine.Grid.t/0","type":"type"},{"doc":"Coordinate Component - represents a square within a grid\n\nCurrently also provides functions for handling coordinate\ntransformations.","ref":"GamesEngine.Grid.Coordinate.html","title":"GamesEngine.Grid.Coordinate","type":"module"},{"doc":"Converts a coordinate's linear index to row/col subscript\n\n| 0 | 3 | 6 |     |0,0|0,1|0,2|\n| 1 | 4 | 7 | --> |1,0|1,1|1,2|\n| 2 | 5 | 8 |     |2,0|2,1|2,2|","ref":"GamesEngine.Grid.Coordinate.html#ind2sub/3","title":"GamesEngine.Grid.Coordinate.ind2sub/3","type":"function"},{"doc":"Creates a new `%Coordinate{}` struct","ref":"GamesEngine.Grid.Coordinate.html#new/1","title":"GamesEngine.Grid.Coordinate.new/1","type":"function"},{"doc":"Converts a coordinate's row/col subscript into a linear index\n\n|0,0|0,1|0,2|     | 0 | 3 | 6 |\n|1,0|1,1|1,2| --> | 1 | 4 | 7 |\n|2,0|2,1|2,2|     | 2 | 5 | 8 |","ref":"GamesEngine.Grid.Coordinate.html#sub2ind/3","title":"GamesEngine.Grid.Coordinate.sub2ind/3","type":"function"},{"doc":"","ref":"GamesEngine.Grid.Coordinate.html#t:t/0","title":"GamesEngine.Grid.Coordinate.t/0","type":"type"},{"doc":"Point component - represents a point in space","ref":"GamesEngine.Grid.Point.html","title":"GamesEngine.Grid.Point","type":"module"},{"doc":"Creates a new `%Point{}` struct","ref":"GamesEngine.Grid.Point.html#new/2","title":"GamesEngine.Grid.Point.new/2","type":"function"},{"doc":"","ref":"GamesEngine.Grid.Point.html#t:t/0","title":"GamesEngine.Grid.Point.t/0","type":"type"},{"doc":"Tile Component\nRepresentation of a Game Tile on a Grid","ref":"GamesEngine.Grid.Tile.html","title":"GamesEngine.Grid.Tile","type":"module"},{"doc":"Adds a new attributes to a `%Tile{}`\nWill not overwrite the attribute if it already exists","ref":"GamesEngine.Grid.Tile.html#add_attribute/3","title":"GamesEngine.Grid.Tile.add_attribute/3","type":"function"},{"doc":"Creates a new `%Tile{}` struct\nrow/col validation is relegated to the `%Coordinate{}` module","ref":"GamesEngine.Grid.Tile.html#new/1","title":"GamesEngine.Grid.Tile.new/1","type":"function"},{"doc":"","ref":"GamesEngine.Grid.Tile.html#new/2","title":"GamesEngine.Grid.Tile.new/2","type":"function"},{"doc":"Replaces the entire attributes map of a `%Tile{}` with a new map","ref":"GamesEngine.Grid.Tile.html#replace_attributes/2","title":"GamesEngine.Grid.Tile.replace_attributes/2","type":"function"},{"doc":"Updates an existing attribute of a `%Tile{}`","ref":"GamesEngine.Grid.Tile.html#update_attribute/3","title":"GamesEngine.Grid.Tile.update_attribute/3","type":"function"},{"doc":"","ref":"GamesEngine.Grid.Tile.html#t:t/0","title":"GamesEngine.Grid.Tile.t/0","type":"type"},{"doc":"Physics context","ref":"GamesEngine.Physics.html","title":"GamesEngine.Physics","type":"module"},{"doc":"Returns a `%Velocity{}` with updated speed components after a horizontal\nor vertical bounce\n\nA :horizontal bounce reflects the `x` component, and a :vertical bounce\nreflects the `y` component","ref":"GamesEngine.Physics.html#bounce/2","title":"GamesEngine.Physics.bounce/2","type":"function"},{"doc":"iex> velocity = %GamesEngine.Physics.Velocity{x: 5, y: 0}\n    iex> GamesEngine.Physics.bounce(velocity, :horizontal)\n    %GamesEngine.Physics.Velocity{x: -5, y: 0}\n\n    iex> velocity = %GamesEngine.Physics.Velocity{x: 0, y: -1.2}\n    iex> GamesEngine.Physics.bounce(velocity, :vertical)\n    %GamesEngine.Physics.Velocity{x: 0, y: 1.2}","ref":"GamesEngine.Physics.html#bounce/2-examples","title":"Examples - GamesEngine.Physics.bounce/2","type":"function"},{"doc":"Calculate's a `%Coordinate{}` or `%Point{}`'s new position based on a `%Velocity{}`\n\nNew `row` and `column` attributes will be rounded to conform with `%Grid{}`\nconstraints when passed a `%Coordinate{}`","ref":"GamesEngine.Physics.html#translate/2","title":"GamesEngine.Physics.translate/2","type":"function"},{"doc":"iex> coordinate = %GamesEngine.Grid.Coordinate{row: 10, col: 10}\n    iex> velocity = %GamesEngine.Physics.Velocity{x: 1, y: -2.5}\n    iex> GamesEngine.Physics.translate(coordinate, velocity)\n    %GamesEngine.Grid.Coordinate{row: 7, col: 11}\n\n    iex> point = %GamesEngine.Grid.Point{x: 10, y: 10}\n    iex> velocity = %GamesEngine.Physics.Velocity{x: 1, y: -2.5}\n    iex> GamesEngine.Physics.translate(point, velocity)\n    %GamesEngine.Grid.Point{x: 11, y: 7.5}","ref":"GamesEngine.Physics.html#translate/2-examples","title":"Examples - GamesEngine.Physics.translate/2","type":"function"},{"doc":"","ref":"GamesEngine.Physics.html#t:bounce_type/0","title":"GamesEngine.Physics.bounce_type/0","type":"type"},{"doc":"Velocity module","ref":"GamesEngine.Physics.Velocity.html","title":"GamesEngine.Physics.Velocity","type":"module"},{"doc":"Creates a new `%Velocity{}` struct with 0 speed in the x and y directions","ref":"GamesEngine.Physics.Velocity.html#new/0","title":"GamesEngine.Physics.Velocity.new/0","type":"function"},{"doc":"Creates a new `%Velocity{}` struct based on a direction vector","ref":"GamesEngine.Physics.Velocity.html#new/1","title":"GamesEngine.Physics.Velocity.new/1","type":"function"},{"doc":"Creates a new `%Velocity{}` struct based on a speed and heading\nHeading is expected in degrees","ref":"GamesEngine.Physics.Velocity.html#new/2","title":"GamesEngine.Physics.Velocity.new/2","type":"function"},{"doc":"","ref":"GamesEngine.Physics.Velocity.html#t:t/0","title":"GamesEngine.Physics.Velocity.t/0","type":"type"},{"doc":"Functions with perform validations of a game grid","ref":"GamesEngine.Validations.GridValidations.html","title":"GamesEngine.Validations.GridValidations","type":"module"},{"doc":"Ensures a linear index is within the bounds of the supplied grid","ref":"GamesEngine.Validations.GridValidations.html#ind_within_bounds/2","title":"GamesEngine.Validations.GridValidations.ind_within_bounds/2","type":"function"},{"doc":"","ref":"GamesEngine.Validations.GridValidations.html#ind_within_bounds/3","title":"GamesEngine.Validations.GridValidations.ind_within_bounds/3","type":"function"},{"doc":"Determines whether a `%Point{}` is within the bounds of a `%Grid{}.\nIf the `%Point{}`'s coordinates are outside the `%Grid{}`, will return an error tuple\nalong with the direction(s) which the `%Point{}` is outside the `%Grid{}`","ref":"GamesEngine.Validations.GridValidations.html#point_within_bounds/2","title":"GamesEngine.Validations.GridValidations.point_within_bounds/2","type":"function"},{"doc":"iex> grid = %GamesEngine.Grid{rows: 10, cols: 10}\n    iex> point = %GamesEngine.Grid.Point{x: 3, y: 5.4}\n    iex> GamesEngine.Validations.GridValidations.point_within_bounds(point, grid)\n    :ok\n\n    iex> grid = %GamesEngine.Grid{rows: 10, cols: 10}\n    iex> point = %GamesEngine.Grid.Point{x: 12, y: -7.3}\n    iex> GamesEngine.Validations.GridValidations.point_within_bounds(point, grid)\n    {:error, %{top: true, bottom: false, right: true, left: false}}","ref":"GamesEngine.Validations.GridValidations.html#point_within_bounds/2-examples","title":"Examples - GamesEngine.Validations.GridValidations.point_within_bounds/2","type":"function"},{"doc":"Ensures a row/col subscript is within the bounds of the supplied grid","ref":"GamesEngine.Validations.GridValidations.html#sub_within_bounds/2","title":"GamesEngine.Validations.GridValidations.sub_within_bounds/2","type":"function"},{"doc":"","ref":"GamesEngine.Validations.GridValidations.html#sub_within_bounds/3","title":"GamesEngine.Validations.GridValidations.sub_within_bounds/3","type":"function"},{"doc":"","ref":"GamesEngine.Validations.GridValidations.html#t:point_within_bounds_errors/0","title":"GamesEngine.Validations.GridValidations.point_within_bounds_errors/0","type":"type"},{"doc":"Functions which perform numeric validations","ref":"GamesEngine.Validations.NumericValidations.html","title":"GamesEngine.Validations.NumericValidations","type":"module"},{"doc":"Ensures the input is a non-negative integer","ref":"GamesEngine.Validations.NumericValidations.html#non_neg_integer/1","title":"GamesEngine.Validations.NumericValidations.non_neg_integer/1","type":"function"},{"doc":"Ensures the input is numeric","ref":"GamesEngine.Validations.NumericValidations.html#numeric/1","title":"GamesEngine.Validations.NumericValidations.numeric/1","type":"function"},{"doc":"Ensures the input is within a given range","ref":"GamesEngine.Validations.NumericValidations.html#within_range/3","title":"GamesEngine.Validations.NumericValidations.within_range/3","type":"function"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}